(import ikernel.*)
(deftemplate Tag	(declare (from-class Tag)))

;********************************************* PROCESSAMENTO DE SINAL ************************************
;************************************** Sistema de Regulao da Velocidade ********************************
(defrule ProcessamentoSinal-UGH1-SRV-1
	(Tag {label == "g1.srv.p.oleo.regulacao" && value != "" && value >= "20" && value <= "50"))
	=>
	(assert (signal-GOOD ?label))
)
(defrule ProcessamentoSinal-UGH1-SRV-2
	(Tag {label == "g1.srv.n.tanque.ar.oleo" && value != "" && value >= "0" && value <= "77"))
	=>
	(assert (signal-GOOD ?label))
)
(defrule ProcessamentoSinal-UGH1-SRV-3
	(Tag {label == "g1.srv.n.oleo.tq.sem.pressao" && value != "" && value >= "20" && value <= "70"))
	=>
	(assert (signal-GOOD ?label))
)
(defrule ProcessamentoSinal-UGH1-SRV-4
	(Tag {label == "g1.srv.t.oleo.tq.sem.pressao" && value != "" && value >= "0" && value <= "60"))
	=>
	(assert (signal-GOOD ?label))
)
;********************************************* MONITORAO DE CONDIO ************************************        
;************************************** Sistema de Regulao da Velocidade ********************************

(defrule UGH1-SRV-MonitoracaoCondicao-1
	(Tag {label == "g1.srv.p.oleo.regulacao" && value != "" && value  >= "32"})
	=>
	(assert (condition-TRIPH ?label))
)	
(defrule UGH1-SRV-MonitoracaoCondicao-2
	(Tag {label == "g1.srv.p.oleo.regulacao" && value != "" && value >= "30" && value < "32"})
	=>
	(assert (condition-HIGH ?label))
)	
(defrule UGH1-SRV-MonitoracaoCondicao-3
	(Tag {label == "g1.srv.p.oleo.regulacao" && value != "" && value > "28" && value < "30"})
	=>
	(assert (condition-NORMAL ?label))
)	
(defrule UGH1-SRV-MonitoracaoCondicao-4
	(Tag {label == "g1.srv.p.oleo.regulacao" && value != "" && value >= "26" && value < "28"})
	=>
	(assert (condition-LOW ?label))
)	
(defrule UGH1-SRV-MonitoracaoCondicao-5
	(Tag {label == "g1.srv.p.oleo.regulacao" && value != "" && value >= "24" && value < "26"})
	=>
	(assert (condition-LLOW ?label))
)
(defrule UGH1-SRV-MonitoracaoCondicao-6
	(Tag {label == "g1.srv.p.oleo.regulacao" && value != "" && value  <= "24"})
	=>
	(assert (condition-TRIPL ?label))
)
(defrule UGH1-SRV-MonitoracaoCondicao-7
	(Tag {label == "g1.srv.n.tanque.ar.oleo" && value != "" && value > "25" && value < "27"})
	=>
	(assert (condition-NORMAL ?label))
)	
(defrule UGH1-SRV-MonitoracaoCondicao-8
	(Tag {label == "g1.srv.n.tanque.ar.oleo" && value != "" && value >= "24" && value < "25"})
	=>
	(assert (condition-LOW ?label))
)	
(defrule UGH1-SRV-MonitoracaoCondicao-9
	(Tag {label == "g1.srv.n.tanque.ar.oleo" && value != "" && value >= "23" && value < "24"})
	=>
	(assert (condition-LLOW ?label))
)
(defrule UGH1-SRV-MonitoracaoCondicao-10
	(Tag {label == "g1.srv.n.tanque.ar.oleo" && value != "" && value >= "20" && value < "23"})
	=>
	(assert (condition-ALARM ?label))
)
(defrule UGH1-SRV-MonitoracaoCondicao-11
	(Tag {label == "g1.srv.n.tanque.ar.oleo" && value != "" && value  <= "20"})
	=>
	(assert (condition-TRIP ?label))
)
(defrule UGH1-SRV-MonitoracaoCondicao-12
	(Tag {label == "g1.srv.n.oleo.tq.sem.pressao" && value != "" && value >= "50"})
	=>
	(assert (condition-HIGH ?label))
)	
(defrule UGH1-SRV-MonitoracaoCondicao-13
	(Tag {label == "g1.srv.n.oleo.tq.sem.pressao" && value != "" && value > "30" && value < "36"})
	=>
	(assert (condition-NORMAL ?label))
)	
(defrule UGH1-SRV-MonitoracaoCondicao-14
	(Tag {label == "g1.srv.n.oleo.tq.sem.pressao" && value != "" && value <= "30"})
	=>
	(assert (condition-LOW ?label))
)	
(defrule UGH1-SRV-MonitoracaoCondicao-15
	(Tag {label == "g1.srv.t.oleo.tq.sem.pressao" && value != "" && value >= "50"})
	=>
	(assert (condition-TRIP ?label))
)	
(defrule UGH1-SRV-MonitoracaoCondicao-16
	(Tag {label == "g1.srv.t.oleo.tq.sem.pressao" && value != "" && value >= "45" && value < "50"})
	=>
	(assert (condition-ALARM ?label))
)
(defrule UGH1-SRV-MonitoracaoCondicao-17
	(Tag {label == "g1.srv.t.oleo.tq.sem.pressao" && value != "" && value >= "40" && value < "45"})
	=>
	(assert (condition-HIGH ?label))
)
(defrule UGH1-SRV-MonitoracaoCondicao-18
	(Tag {label == "g1.srv.t.oleo.tq.sem.pressao" && value != "" && value > "35" && value < "40"})
	=>
	(assert (condition-NORMAL ?label))
)

;***************************************** DIAGNOSTICO **********************************************
;******************************* Sistema de Regulao da Velocidade *********************************
(defrule UGH1-SRV-Diagnostico-1
	(signal-GOOD "g1.srv.p.oleo.regulacao")
	(condition-TRIPH "g1.srv.p.oleo.regulacao")
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1PTQAROLEOTA2#operators#")
)
(defrule UGH1-SRV-Diagnostico-2
	(signal-GOOD "g1.srv.p.oleo.regulacao")
	(condition-HIGH "g1.srv.p.oleo.regulacao")
	=>
	(printout gui14 "srv-amarelo#")
	(printout gui12 "G1PTQAROLEOAT2#operators#")
)
(defrule UGH1-SRV-Diagnostico-3
	(signal-GOOD "g1.srv.p.oleo.regulacao")
	(condition-LOW "g1.srv.p.oleo.regulacao")
	=>
	(printout gui14 "srv-amarelo#")
	(printout gui12 "G1PTQAROLEOBA2#operators#")
)
(defrule UGH1-SRV-Diagnostico-4
	(signal-GOOD "g1.srv.p.oleo.regulacao")
	(condition-LLOW "g1.srv.p.oleo.regulacao")
	=>
	(printout gui14 "srv-amrelo#")
	(printout gui12 "G1PTQAROLEOMB2#operators#")
)
(defrule UGH1-SRV-Diagnostico-5
	(signal-GOOD "g1.srv.p.oleo.regulacao")
	(condition-TRIPL "g1.srv.p.oleo.regulacao")
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1PTQAROLEOTB2#operators#")
)
(defrule UGH1-SRV-Diagnostico-6
	(signal-GOOD "g1.srv.n.oleo.regulacao")
	(condition-LOW "g1.srv.n.oleo.regulacao")
	=>
	(printout gui14 "srv-amarelo#")
	(printout gui12 "G1NTQAROLEOBA2#operators#")
)
(defrule UGH1-SRV-Diagnostico-7
	(signal-GOOD "g1.srv.n.oleo.regulacao")
	(condition-LLOW "g1.srv.n.oleo.regulacao")
	=>
	(printout gui14 "srv-amarelo#")
	(printout gui12 "G1NTQAROLEOMB2#operators#")
)
(defrule UGH1-SRV-Diagnostico-8
	(signal-GOOD "g1.srv.n.oleo.regulacao")
	(condition-ALARM "g1.srv.n.oleo.regulacao")
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1NTQAROLEOAL2#operators#")
)
(defrule UGH1-SRV-Diagnostico-9
	(signal-GOOD "g1.srv.n.oleo.regulacao")
	(condition-TRIPL "g1.srv.n.oleo.regulacao")
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1NTQAROLEOTB2#operators#")
)
(defrule UGH1-SRV-Diagnostico-10
	(signal-GOOD "g1.srv.n.oleo.tq.sem.pressao")
	(condition-HIGH "g1.srv.n.oleo.tq.sem.pressao")
	=>
	(printout gui14 "srv-amarelo#")
	(printout gui12 "G1NTQSEMPRESSAOAT2#operators#")
)
(defrule UGH1-SRV-Diagnostico-11
	(signal-GOOD "g1.srv.n.oleo.tq.sem.pressao")
	(condition-LOW "g1.srv.n.oleo.tq.sem.pressao")
	=>
	(printout gui14 "srv-amarelo#")
	(printout gui12 "G1NTQSEMPRESSAOBA2#operators#")
)
(defrule UGH1-SRV-Diagnostico-12
	(signal-GOOD "g1.srv.t.oleo.tq.sem.pressao")
	(condition-TRIP "g1.srv.t.oleo.tq.sem.pressao")
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1NTQSEMPRESSAOTA2#operators#")
)
(defrule UGH1-SRV-Diagnostico-13
	(signal-GOOD "g1.srv.t.oleo.tq.sem.pressao")
	(condition-ALARM "g1.srv.t.oleo.tq.sem.pressao")
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1NTQSEMPRESSAOAL2#operators#")
)
(defrule UGH1-SRV-Diagnostico-14
	(signal-GOOD "g1.srv.t.oleo.tq.sem.pressao")
	(condition-HIGH "g1.srv.t.oleo.tq.sem.pressao")
	=>
	(printout gui14 "srv-amarelo#")
	(printout gui12 "G1NTQSEMPRESSAOAT2#operators#")
)
(defrule UGH1-SRV-Diagnostico-15
	(Tag {label == "g1.srv.n.max.tanque.ar.oleo" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1NMAXTQAROLEO#operators#")
)
(defrule UGH1-SRV-Diagnostico-17
	(Tag {label == "g1.srv.n.min.tanque.ar.oleo" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1NMINTQAROLEO#operators#")
)
(defrule UGH1-SRV-Diagnostico-18
	(Tag {label == "g1.srv.f.duplo.sujo.tanque.ar.oleo" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1FDSSUJOTQSEMPRESS#operators#")
)
(defrule UGH1-SRV-Diagnostico-19
	(Tag {label == "g1.srv.f.retorno.sujo.tanque.ar.oleo" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1FRSSUJOTQSEMPRESS#operators#")
)
(defrule UGH1-SRV-Diagnostico-20
	(Tag {label == "g1.srv.termica.atuado.bb1" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1TBB1ATUADO#operators#")
)

(defrule UGH1-SRV-Diagnostico-21
	(Tag {label == "g1.srv.falta.tensao.bb1" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1VBB1FALTATENSAO#operators#")
)
(defrule UGH1-SRV-Diagnostico-22
	(Tag {label == "g1.srv.termica.atuado.bb2" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1TBB2ATUADO#operators#")
)
(defrule UGH1-SRV-Diagnostico-23
	(Tag {label == "g1.srv.falta.tensao.bb2" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1VBB2FALTATENSAO#operators#")
)
(defrule UGH1-SRV-Diagnostico-24
	(Tag {label == "g1.srv.p.menor.27.5" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1PMENOR275#operators#")
)
(defrule UGH1-SRV-Diagnostico-25
	(Tag {label == "g1.srv.falta.220.controle.puh" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1VFALTA220PUH#operators#")
)
(defrule UGH1-SRV-Diagnostico-26
	(Tag {label == "g1.srv.defeitorv" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1DEFEITORV#operators#")
)
(defrule UGH1-SRV-Diagnostico-27
	(Tag {label == "g1.srv.sobrevelocidade" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1SOBREVELOCIDADE#operators#")
)
(defrule UGH1-SRV-Diagnostico-28
	(Tag {label == "g1.srv.cpu1queimada" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1CPU1QUEIMADA#operators#")
)
(defrule UGH1-SRV-Diagnostico-29
	(Tag {label == "g1.srv.ihmtravada" && value == "1"})
	=>
	(printout gui14 "srv-vermelho#")
	(printout gui12 "G1IHMTRAVADA#operators#")
)
;******************************* Sistema Distribuidor da Turbina *********************************
(defrule UGH1-SRV-Diagnostico-30
	(Tag {label == "g1.srv.quebrapino" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO#operators#")
)
(defrule UGH1-SRV-Diagnostico-31
	(Tag {label == "g1.srv.quebrapino01" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO01#operators#")
)
(defrule UGH1-SRV-Diagnostico-32
	(Tag {label == "g1.srv.quebrapino02" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO02#operators#")
)
(defrule UGH1-SRV-Diagnostico-33
	(Tag {label == "g1.srv.quebrapino03" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO03#operators#")
)
(defrule UGH1-SRV-Diagnostico-34
	(Tag {label == "g1.srv.quebrapino04" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO04#operators#")
)
(defrule UGH1-SRV-Diagnostico-35
	(Tag {label == "g1.srv.quebrapino05" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO05#operators#")
)
(defrule UGH1-SRV-Diagnostico-36
	(Tag {label == "g1.srv.quebrapino06" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO06#operators#")
)
(defrule UGH1-SRV-Diagnostico-37
	(Tag {label == "g1.srv.quebrapino07" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO07#operators#")
)
(defrule UGH1-SRV-Diagnostico-38
	(Tag {label == "g1.srv.quebrapino08" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO08#operators#")
)
(defrule UGH1-SRV-Diagnostico-39
	(Tag {label == "g1.srv.quebrapino09" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO09#operators#")
)
(defrule UGH1-SRV-Diagnostico-40
	(Tag {label == "g1.srv.quebrapino10" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO10#operators#")
)
(defrule UGH1-SRV-Diagnostico-41
	(Tag {label == "g1.srv.quebrapino11" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO11#operators#")
)
(defrule UGH1-SRV-Diagnostico-42
	(Tag {label == "g1.srv.quebrapino12" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO12#operators#")
)
(defrule UGH1-SRV-Diagnostico-43
	(Tag {label == "g1.srv.quebrapino13" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO13#operators#")
)
(defrule UGH1-SRV-Diagnostico-44
	(Tag {label == "g1.srv.quebrapino14" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO14#operators#")
)
(defrule UGH1-SRV-Diagnostico-45
	(Tag {label == "g1.srv.quebrapino15" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO15#operators#")
)
(defrule UGH1-SRV-Diagnostico-46
	(Tag {label == "g1.srv.quebrapino16" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO16#operators#")
)
(defrule UGH1-SRV-Diagnostico-47
	(Tag {label == "g1.srv.quebrapino17" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO17#operators#")
)
(defrule UGH1-SRV-Diagnostico-48
	(Tag {label == "g1.srv.quebrapino18" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO18#operators#")
)
(defrule UGH1-SRV-Diagnostico-49
	(Tag {label == "g1.srv.quebrapino19" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO19#operators#")
)
(defrule UGH1-SRV-Diagnostico-50
	(Tag {label == "g1.srv.quebrapino20" && value == "1"})
	=>
	(printout gui14 "sdt-vermelho#")
	(printout gui12 "G1QUEBRAPINO20#operators#")
)









