(import ikernel.*)
(deftemplate Tag	(declare (from-class Tag)))

;********************************************* PROCESSAMENTO DE SINAL ************************************
;************************************** Sistema de Regulao da Velocidade ********************************
(defrule ProcessamentoSinal-UGH2-SRV-1
	(Tag {label == "g2.srv.p.oleo.regulacao" && value != "" && value >= "20" && value <= "50"))
	=>
	(assert (signal-GOOD ?label))
)
(defrule ProcessamentoSinal-UGH2-SRV-2
	(Tag {label == "g2.srv.n.tanque.ar.oleo" && value != "" && value >= "0" && value <= "77"))
	=>
	(assert (signal-GOOD ?label))
)
(defrule ProcessamentoSinal-UGH2-SRV-3
	(Tag {label == "g2.srv.n.oleo.tq.sem.pressao" && value != "" && value >= "20" && value <= "70"))
	=>
	(assert (signal-GOOD ?label))
)
(defrule ProcessamentoSinal-UGH2-SRV-4
	(Tag {label == "g2.srv.t.oleo.tq.sem.pressao" && value != "" && value >= "0" && value <= "60"))
	=>
	(assert (signal-GOOD ?label))
)
;********************************************* MONITORAO DE CONDIO ************************************        
;************************************** Sistema de Regulao da Velocidade ********************************

(defrule UGH2-SRV-MonitoracaoCondicao-1
	(Tag {label == "g2.srv.p.oleo.regulacao" && value != "" && value  >= "32"})
	=>
	(assert (condition-TRIPH ?label))
)	
(defrule UGH2-SRV-MonitoracaoCondicao-2
	(Tag {label == "g2.srv.p.oleo.regulacao" && value != "" && value >= "30" && value < "32"})
	=>
	(assert (condition-HIGH ?label))
)	
(defrule UGH2-SRV-MonitoracaoCondicao-3
	(Tag {label == "g2.srv.p.oleo.regulacao" && value != "" && value > "28" && value < "30"})
	=>
	(assert (condition-NORMAL ?label))
)	
(defrule UGH2-SRV-MonitoracaoCondicao-4
	(Tag {label == "g2.srv.p.oleo.regulacao" && value != "" && value >= "26" && value < "28"})
	=>
	(assert (condition-LOW ?label))
)	
(defrule UGH2-SRV-MonitoracaoCondicao-5
	(Tag {label == "g2.srv.p.oleo.regulacao" && value != "" && value >= "24" && value < "26"})
	=>
	(assert (condition-LLOW ?label))
)
(defrule UGH2-SRV-MonitoracaoCondicao-6
	(Tag {label == "g2.srv.p.oleo.regulacao" && value != "" && value  <= "24"})
	=>
	(assert (condition-TRIPL ?label))
)
(defrule UGH2-SRV-MonitoracaoCondicao-7
	(Tag {label == "g2.srv.n.tanque.ar.oleo" && value != "" && value > "25" && value < "27"})
	=>
	(assert (condition-NORMAL ?label))
)	
(defrule UGH2-SRV-MonitoracaoCondicao-8
	(Tag {label == "g2.srv.n.tanque.ar.oleo" && value != "" && value >= "24" && value < "25"})
	=>
	(assert (condition-LOW ?label))
)	
(defrule UGH2-SRV-MonitoracaoCondicao-9
	(Tag {label == "g2.srv.n.tanque.ar.oleo" && value != "" && value >= "23" && value < "24"})
	=>
	(assert (condition-LLOW ?label))
)
(defrule UGH2-SRV-MonitoracaoCondicao-10
	(Tag {label == "g2.srv.n.tanque.ar.oleo" && value != "" && value >= "20" && value < "23"})
	=>
	(assert (condition-ALARM ?label))
)
(defrule UGH2-SRV-MonitoracaoCondicao-11
	(Tag {label == "g2.srv.n.tanque.ar.oleo" && value != "" && value  <= "20"})
	=>
	(assert (condition-TRIP ?label))
)
(defrule UGH2-SRV-MonitoracaoCondicao-12
	(Tag {label == "g2.srv.n.oleo.tq.sem.pressao" && value != "" && value >= "50"})
	=>
	(assert (condition-HIGH ?label))
)	
(defrule UGH2-SRV-MonitoracaoCondicao-13
	(Tag {label == "g2.srv.n.oleo.tq.sem.pressao" && value != "" && value > "30" && value < "36"})
	=>
	(assert (condition-NORMAL ?label))
)	
(defrule UGH2-SRV-MonitoracaoCondicao-14
	(Tag {label == "g2.srv.n.oleo.tq.sem.pressao" && value != "" && value <= "30"})
	=>
	(assert (condition-LOW ?label))
)	
(defrule UGH2-SRV-MonitoracaoCondicao-15
	(Tag {label == "g2.srv.t.oleo.tq.sem.pressao" && value != "" && value >= "50"})
	=>
	(assert (condition-TRIP ?label))
)	
(defrule UGH2-SRV-MonitoracaoCondicao-16
	(Tag {label == "g2.srv.t.oleo.tq.sem.pressao" && value != "" && value >= "45" && value < "50"})
	=>
	(assert (condition-ALARM ?label))
)
(defrule UGH2-SRV-MonitoracaoCondicao-17
	(Tag {label == "g2.srv.t.oleo.tq.sem.pressao" && value != "" && value >= "40" && value < "45"})
	=>
	(assert (condition-HIGH ?label))
)
(defrule UGH2-SRV-MonitoracaoCondicao-18
	(Tag {label == "g2.srv.t.oleo.tq.sem.pressao" && value != "" && value > "35" && value < "40"})
	=>
	(assert (condition-NORMAL ?label))
)

;***************************************** DIAGNOSTICO **********************************************
;******************************* Sistema de Regulao da Velocidade *********************************
(defrule UGH2-SRV-Diagnostico-1
	(signal-GOOD "g2.srv.p.oleo.regulacao")
	(condition-TRIPH "g2.srv.p.oleo.regulacao")
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2PTQAROLEOTA2#operators#")
)
(defrule UGH2-SRV-Diagnostico-2
	(signal-GOOD "g2.srv.p.oleo.regulacao")
	(condition-HIGH "g2.srv.p.oleo.regulacao")
	=>
	(printout gui24 "srv-amarelo#")
	(printout gui22 "G2PTQAROLEOAT2#operators#")
)
(defrule UGH2-SRV-Diagnostico-3
	(signal-GOOD "g2.srv.p.oleo.regulacao")
	(condition-LOW "g2.srv.p.oleo.regulacao")
	=>
	(printout gui24 "srv-amarelo#")
	(printout gui22 "G2PTQAROLEOBA2#operators#")
)
(defrule UGH2-SRV-Diagnostico-4
	(signal-GOOD "g2.srv.p.oleo.regulacao")
	(condition-LLOW "g2.srv.p.oleo.regulacao")
	=>
	(printout gui24 "srv-amrelo#")
	(printout gui22 "G2PTQAROLEOMB2#operators#")
)
(defrule UGH2-SRV-Diagnostico-5
	(signal-GOOD "g2.srv.p.oleo.regulacao")
	(condition-TRIPL "g2.srv.p.oleo.regulacao")
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2PTQAROLEOTB2#operators#")
)
(defrule UGH2-SRV-Diagnostico-6
	(signal-GOOD "g2.srv.n.oleo.regulacao")
	(condition-LOW "g2.srv.n.oleo.regulacao")
	=>
	(printout gui24 "srv-amarelo#")
	(printout gui22 "G2NTQAROLEOBA2#operators#")
)
(defrule UGH2-SRV-Diagnostico-7
	(signal-GOOD "g2.srv.n.oleo.regulacao")
	(condition-LLOW "g2.srv.n.oleo.regulacao")
	=>
	(printout gui24 "srv-amarelo#")
	(printout gui22 "G2NTQAROLEOMB2#operators#")
)
(defrule UGH2-SRV-Diagnostico-8
	(signal-GOOD "g2.srv.n.oleo.regulacao")
	(condition-ALARM "g2.srv.n.oleo.regulacao")
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2NTQAROLEOAL2#operators#")
)
(defrule UGH2-SRV-Diagnostico-9
	(signal-GOOD "g2.srv.n.oleo.regulacao")
	(condition-TRIPL "g2.srv.n.oleo.regulacao")
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2NTQAROLEOTB2#operators#")
)
(defrule UGH2-SRV-Diagnostico-10
	(signal-GOOD "g2.srv.n.oleo.tq.sem.pressao")
	(condition-HIGH "g2.srv.n.oleo.tq.sem.pressao")
	=>
	(printout gui24 "srv-amarelo#")
	(printout gui22 "G2NTQSEMPRESSAOAT2#operators#")
)
(defrule UGH2-SRV-Diagnostico-11
	(signal-GOOD "g2.srv.n.oleo.tq.sem.pressao")
	(condition-LOW "g2.srv.n.oleo.tq.sem.pressao")
	=>
	(printout gui24 "srv-amarelo#")
	(printout gui22 "G2NTQSEMPRESSAOBA2#operators#")
)
(defrule UGH2-SRV-Diagnostico-12
	(signal-GOOD "g2.srv.t.oleo.tq.sem.pressao")
	(condition-TRIP "g2.srv.t.oleo.tq.sem.pressao")
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2NTQSEMPRESSAOTA2#operators#")
)
(defrule UGH2-SRV-Diagnostico-13
	(signal-GOOD "g2.srv.t.oleo.tq.sem.pressao")
	(condition-ALARM "g2.srv.t.oleo.tq.sem.pressao")
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2NTQSEMPRESSAOAL2#operators#")
)
(defrule UGH2-SRV-Diagnostico-14
	(signal-GOOD "g2.srv.t.oleo.tq.sem.pressao")
	(condition-HIGH "g2.srv.t.oleo.tq.sem.pressao")
	=>
	(printout gui24 "srv-amarelo#")
	(printout gui22 "G2NTQSEMPRESSAOAT2#operators#")
)
(defrule UGH2-SRV-Diagnostico-15
	(Tag {label == "g2.srv.n.max.tanque.ar.oleo" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2NMAXTQAROLEO#operators#")
)
(defrule UGH2-SRV-Diagnostico-17
	(Tag {label == "g2.srv.n.min.tanque.ar.oleo" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2NMINTQAROLEO#operators#")
)
(defrule UGH2-SRV-Diagnostico-18
	(Tag {label == "g2.srv.f.duplo.sujo.tanque.ar.oleo" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2FDSSUJOTQSEMPRESS#operators#")
)
(defrule UGH2-SRV-Diagnostico-19
	(Tag {label == "g2.srv.f.retorno.sujo.tanque.ar.oleo" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2FRSSUJOTQSEMPRESS#operators#")
)
(defrule UGH2-SRV-Diagnostico-20
	(Tag {label == "g2.srv.termica.atuado.bb1" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2TBB1ATUADO#operators#")
)

(defrule UGH2-SRV-Diagnostico-21
	(Tag {label == "g2.srv.falta.tensao.bb1" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2VBB1FALTATENSAO#operators#")
)
(defrule UGH2-SRV-Diagnostico-22
	(Tag {label == "g2.srv.termica.atuado.bb2" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2TBB2ATUADO#operators#")
)
(defrule UGH2-SRV-Diagnostico-23
	(Tag {label == "g2.srv.falta.tensao.bb2" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2VBB2FALTATENSAO#operators#")
)
(defrule UGH2-SRV-Diagnostico-24
	(Tag {label == "g2.srv.p.menor.27.5" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2PMENOR275#operators#")
)
(defrule UGH2-SRV-Diagnostico-25
	(Tag {label == "g2.srv.falta.220.controle.puh" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2VFALTA220PUH#operators#")
)
(defrule UGH2-SRV-Diagnostico-26
	(Tag {label == "g2.srv.defeitorv" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2DEFEITORV#operators#")
)
(defrule UGH2-SRV-Diagnostico-27
	(Tag {label == "g2.srv.sobrevelocidade" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2SOBREVELOCIDADE#operators#")
)
(defrule UGH2-SRV-Diagnostico-28
	(Tag {label == "g2.srv.cpu1queimada" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2CPU1QUEIMADA#operators#")
)
(defrule UGH2-SRV-Diagnostico-29
	(Tag {label == "g2.srv.ihmtravada" && value == "1"})
	=>
	(printout gui24 "srv-vermelho#")
	(printout gui22 "G2IHMTRAVADA#operators#")
)

;******************************* Sistema Distribuidor da Turbina *********************************
(defrule UGH2-SRV-Diagnostico-30
	(Tag {label == "g2.srv.quebrapino" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO#operators#")
)
(defrule UGH2-SRV-Diagnostico-31
	(Tag {label == "g2.srv.quebrapino01" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO01#operators#")
)
(defrule UGH2-SRV-Diagnostico-32
	(Tag {label == "g2.srv.quebrapino02" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO02#operators#")
)
(defrule UGH2-SRV-Diagnostico-33
	(Tag {label == "g2.srv.quebrapino03" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO03#operators#")
)
(defrule UGH2-SRV-Diagnostico-34
	(Tag {label == "g2.srv.quebrapino04" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO04#operators#")
)
(defrule UGH2-SRV-Diagnostico-35
	(Tag {label == "g2.srv.quebrapino05" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO05#operators#")
)
(defrule UGH2-SRV-Diagnostico-36
	(Tag {label == "g2.srv.quebrapino06" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO06#operators#")
)
(defrule UGH2-SRV-Diagnostico-37
	(Tag {label == "g2.srv.quebrapino07" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO07#operators#")
)
(defrule UGH2-SRV-Diagnostico-38
	(Tag {label == "g2.srv.quebrapino08" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO08#operators#")
)
(defrule UGH2-SRV-Diagnostico-39
	(Tag {label == "g2.srv.quebrapino09" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO09#operators#")
)
(defrule UGH2-SRV-Diagnostico-40
	(Tag {label == "g2.srv.quebrapino10" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO10#operators#")
)
(defrule UGH2-SRV-Diagnostico-41
	(Tag {label == "g2.srv.quebrapino11" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO11#operators#")
)
(defrule UGH2-SRV-Diagnostico-42
	(Tag {label == "g2.srv.quebrapino12" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO12#operators#")
)
(defrule UGH2-SRV-Diagnostico-43
	(Tag {label == "g2.srv.quebrapino13" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO13#operators#")
)
(defrule UGH2-SRV-Diagnostico-44
	(Tag {label == "g2.srv.quebrapino14" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO14#operators#")
)
(defrule UGH2-SRV-Diagnostico-45
	(Tag {label == "g2.srv.quebrapino15" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO15#operators#")
)
(defrule UGH2-SRV-Diagnostico-46
	(Tag {label == "g2.srv.quebrapino16" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO16#operators#")
)
(defrule UGH2-SRV-Diagnostico-47
	(Tag {label == "g2.srv.quebrapino17" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO17#operators#")
)
(defrule UGH2-SRV-Diagnostico-48
	(Tag {label == "g2.srv.quebrapino18" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO18#operators#")
)
(defrule UGH2-SRV-Diagnostico-49
	(Tag {label == "g2.srv.quebrapino19" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO19#operators#")
)
(defrule UGH2-SRV-Diagnostico-50
	(Tag {label == "g2.srv.quebrapino20" && value == "1"})
	=>
	(printout gui24 "sdt-vermelho#")
	(printout gui22 "G2QUEBRAPINO20#operators#")
)










